#!/usr/bin/python
# -*- coding: utf-8 -*-

import wav

dzSet,szDic = set(),{}

for line in open('data/Gloska.txt'):
	if line.startswith('#stopien_zblizenia'):
		part = 0
		continue
	elif line.startswith('#dzwieczne'):
		part = 1
		continue
	
	if part == 0:
		val, keys = line.strip().decode('utf-8').split(':')
		for k in keys.split(','):
			szDic[k] = val
	elif part == 1:
		for gl in line.strip().decode('utf-8').split(','):
			dzSet.add(gl)
			
dz_bdz = map(lambda line: line.strip().decode('utf-8').split(),open('data/dz_bdz.txt'))	
dz_bdz = dict(dz_bdz + map(lambda (x, y): (y,x), dz_bdz))



class Gloska:
	
	def __init__(self, name):
		self.name = name
		self.dzwieczna = name in dzSet
		self.stopien_zblizenia = szDic[name] 
		self.typ = u'samogłoska' if self.stopien_zblizenia == u'otwarta' else u'spółgłoska'
		self.nosowa = name[-1] == u'n' or self.stopien_zblizenia == u'nosowa'
		self.akcent = False
		self.bytes = None
		
	def get_bytes(self):
		self.bytes = wav.getA(self.name) if self.akcent else wav.get(self.name)
		return self.bytes
	
	def isVowel(self):
		return self.typ == u'samogłoska'
	
	def udzwiecznij(self):
		if self.dzwieczna:
			raise Exception('Gloska już jest dźwięczna!')
		if self.name in dz_bdz.keys():
			self.name = dz_bdz[self.name]	
		self.dzwieczna = True
	def ubezdzwiecznij(self):
		if not self.dzwieczna:
			raise Exception('Głoska już jest bezdźwięczna!')
		if self.name in dz_bdz.keys():
			self.name = dz_bdz[self.name]	
		self.dzwieczna = False
	def zmien_dzwiecznosc(self):
		if self.dzwieczna:
			self.ubezdzwiecznij()
		else:
			self.udzwiecznij()
		
	def nazalizuj(self):
		if not self.typ == u'samogłoska':
			raise Exception('Unosowić można jedynie samogłoskę!')
		if self.nosowa is True:
			raise Exception('Głoska jest już nosowa!')
		self.name += u'n'
		self.nosowa = True
		
	def zaakcentuj(self):
		self.akcent = True
	
	def __repr__(self):
		return u'<"%s"(%s)>' % (self.name, u'dz' if self.dzwieczna else u'bdz')
	
	def __str__(self):
		return u'<%s>' % self.name	